org.eclipse.jetty.server.handler

## Class ErrorHandler

- java.lang.Object
- - org.eclipse.jetty.util.component.AbstractLifeCycle
  - - org.eclipse.jetty.util.component.AggregateLifeCycle
    - - org.eclipse.jetty.server.handler.AbstractHandler
      - - org.eclipse.jetty.server.handler.ErrorHandler

All Implemented Interfaces:
  Handler, Destroyable, Dumpable, LifeCycle

Direct Known Subclasses:
  ErrorPageErrorHandler

    public class ErrorHandler
    extends AbstractHandler

Handler for Error pages An ErrorHandler is registered with `ContextHandler.setErrorHandler(ErrorHandler)` or `Server.addBean(Object)`. It is called by the HttpResponse.sendError method to write a error page.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle

`AbstractLifeCycle.AbstractLifeCycleListener`

### Nested classes/interfaces inherited from interface org.eclipse.jetty.util.component.LifeCycle

`LifeCycle.Listener`

### Field Summary

### Fields inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle

`_listeners, FAILED, RUNNING, STARTED, STARTING, STOPPED, STOPPING`

### Constructor Summary

Constructors
Constructor and Description
`ErrorHandler()`

### Method Summary

Methods
`String` `getCacheControl()` Get the cacheControl.
`boolean` `getShowMessageInTitle()`
`void` `handle(String target, Request baseRequest, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)` Handle a request.
`protected void` `handleErrorPage(javax.servlet.http.HttpServletRequest request, Writer writer, int code, String message)`
`boolean` `isShowStacks()`
`void` `setCacheControl(String cacheControl)` Set the cacheControl.
`void` `setShowMessageInTitle(boolean showMessageInTitle)`
`void` `setShowStacks(boolean showStacks)`
`protected void` `write(Writer writer, String string)`
`protected void` `writeErrorPage(javax.servlet.http.HttpServletRequest request, Writer writer, int code, String message, boolean showStacks)`
`protected void` `writeErrorPageBody(javax.servlet.http.HttpServletRequest request, Writer writer, int code, String message, boolean showStacks)`
`protected void` `writeErrorPageHead(javax.servlet.http.HttpServletRequest request, Writer writer, int code, String message)`
`protected void` `writeErrorPageMessage(javax.servlet.http.HttpServletRequest request, Writer writer, int code, String message, String uri)`
`protected void` `writeErrorPageStacks(javax.servlet.http.HttpServletRequest request, Writer writer)`

### Methods inherited from class org.eclipse.jetty.server.handler.AbstractHandler

`destroy, doStart, doStop, dumpThis, getServer, setServer`

### Methods inherited from class org.eclipse.jetty.util.component.AggregateLifeCycle

`addBean, addBean, contains, dump, dump, dump, dump, dump, dumpObject, dumpStdErr, getBean, getBeans, getBeans, isManaged, manage, removeBean, removeBeans, unmanage`

### Methods inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle

`addLifeCycleListener, getState, getState, isFailed, isRunning, isStarted, isStarting, isStopped, isStopping, removeLifeCycleListener, start, stop`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.eclipse.jetty.util.component.LifeCycle

`addLifeCycleListener, isFailed, isRunning, isStarted, isStarting, isStopped, isStopping, removeLifeCycleListener, start, stop`

### Constructor Detail

#### ErrorHandler

    public ErrorHandler()

### Method Detail

#### handle

    public void handle(String target,
              Request baseRequest,
              javax.servlet.http.HttpServletRequest request,
              javax.servlet.http.HttpServletResponse response)
                throws IOException

Description copied from interface: `Handler`
Handle a request.

Parameters:
  `target` - The target of the request - either a URI or a name.
  `baseRequest` - The original unwrapped request object.
  `request` - The request either as the `Request` object or a wrapper of that request. The `AbstractHttpConnection.getCurrentConnection()` method can be used access the Request object if required.
  `response` - The response as the `Response` object or a wrapper of that request. The `AbstractHttpConnection.getCurrentConnection()` method can be used access the Response object if required.
Throws:
  `IOException`

#### handleErrorPage

    protected void handleErrorPage(javax.servlet.http.HttpServletRequest request,
                       Writer writer,
                       int code,
                       String message)
                            throws IOException

Throws:
  `IOException`

#### writeErrorPage

    protected void writeErrorPage(javax.servlet.http.HttpServletRequest request,
                      Writer writer,
                      int code,
                      String message,
                      boolean showStacks)
                           throws IOException

Throws:
  `IOException`

#### writeErrorPageHead

    protected void writeErrorPageHead(javax.servlet.http.HttpServletRequest request,
                          Writer writer,
                          int code,
                          String message)
                               throws IOException

Throws:
  `IOException`

#### writeErrorPageBody

    protected void writeErrorPageBody(javax.servlet.http.HttpServletRequest request,
                          Writer writer,
                          int code,
                          String message,
                          boolean showStacks)
                               throws IOException

Throws:
  `IOException`

#### writeErrorPageMessage

    protected void writeErrorPageMessage(javax.servlet.http.HttpServletRequest request,
                             Writer writer,
                             int code,
                             String message,
                             String uri)
                                  throws IOException

Throws:
  `IOException`

#### writeErrorPageStacks

    protected void writeErrorPageStacks(javax.servlet.http.HttpServletRequest request,
                            Writer writer)
                                 throws IOException

Throws:
  `IOException`

#### getCacheControl

    public String getCacheControl()

Get the cacheControl.

Returns:
  the cacheControl header to set on error responses.

#### setCacheControl

    public void setCacheControl(String cacheControl)

Set the cacheControl.

Parameters:
  `cacheControl` - the cacheControl header to set on error responses.

#### isShowStacks

    public boolean isShowStacks()

Returns:
  True if stack traces are shown in the error pages

#### setShowStacks

    public void setShowStacks(boolean showStacks)

Parameters:
  `showStacks` - True if stack traces are shown in the error pages

#### setShowMessageInTitle

    public void setShowMessageInTitle(boolean showMessageInTitle)

Parameters:
  `showMessageInTitle` - if true, the error message appears in page title

#### getShowMessageInTitle

    public boolean getShowMessageInTitle()

#### write

    protected void write(Writer writer,
             String string)
                  throws IOException

Throws:
  `IOException`